/**
 * License Agreement.
 *
 *  JBoss RichFaces - Ajax4jsf Component Library
 *
 * Copyright (C) 2007  Exadel, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */
package org.richfaces.realworld.util;

import java.util.ArrayList;
import java.util.List;

import javax.faces.context.FacesContext;

import org.ajax4jsf.context.AjaxContext;
import org.jboss.seam.ScopeType;
import org.jboss.seam.annotations.AutoCreate;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Observer;
import org.jboss.seam.annotations.Scope;
import org.richfaces.realworld.service.Constants;

@Name("errorHandlerBean")
@Scope(ScopeType.EVENT)
@AutoCreate
public class ErrorHandlerBean {
	private List<Exception> errors = new ArrayList<Exception>();

	public List<Exception> getErrors() {
		return errors;
	}

	public void setErrors(List<Exception> errors) {
		this.errors = errors;
	}
	
	public boolean isErrorExist(){
		return errors.size() > 0 ;
	}
	
	@Observer(Constants.CLEAR_ERROR_EVENT)
	public void clearEvents(){
		errors.clear();
	}
	
	@Observer(Constants.ADD_ERROR_EVENT)
	public void addToErrors(Exception e){
		FacesContext context = FacesContext.getCurrentInstance();
		AjaxContext ac = AjaxContext.getCurrentInstance(context);
		//TODO nick - should add to AjaxContext#getAjaxAreasToRender()
		ac.addRenderedArea(Constants.ERROR_ID);
		errors.add(e);
	}
}
